<%@
      page language="java" contentType="text/html; charset=UTF-8"
%><%@ page import = "org.jdom.Element,
					 com.oberon.ooql.sdk.*,
                     com.oberon.ooql.rmi.JRClient,
                     java.lang.*,
                     java.util.*,
                     java.io.*,
                     java.text.*,
					 java.net.URLEncoder"
%><%!
   // APPLICATION PARAMETERS ---------------------------------------------------

   // Application Title
   static public final String application_Title="Oberon PLM - Demo";
   // Oberon Application Main Menu
   static public final String application_MainMenu="PLM_Application";
   // Dictionary Menu section
   static public final String dictionary_MenuSection="PLM_Menu";
   // Dictionary Common section
   static public final String dictionary_CommonSection="Common";

   // Anonymous User Account (if empty requires user login)
   static public final String anonymousUser         = "";
   static public final String anonymousUserPassword = "";
   
   // Browser Language
   static public final boolean use_browser_language = false;
   // Default Language
   static public final String dictionary_default_language = "EN";

   // Menu File Path
   static public final String menu_files_path = "menu_files";
   
   // Show the Object class in the result lists
   static public boolean show_object_class = true;
   // Show the Object name / revision in the result lists
   static public boolean show_object_namerev = true;
   // Use the search patterns for text fields
   static public boolean use_search_patterns = true;
   // Use the fixed decimal separator
   static public String number_separator_symbols = "";
   // --------------------------------------------------------------------------

   static public String dictSection = "";
   static public String applicationPath= "";
   static public final String nameRevSep = ".";
   static public Hashtable langSupportTranslation = null;
   static public Hashtable langReverseTranslation = null;

   // Convert the browser language code to the corresponding Oberon dictionary language code
   static private String translateBrowserLanguageToOberonLanguage(String sBrowserLanguage) {
	  String LANGUAGE = sBrowserLanguage;
 	  if (langSupportTranslation == null ) {
 		  langSupportTranslation = new Hashtable();
 		  // Edit this part to define associations
 		  langSupportTranslation.put("en-us","EN");
 		  langSupportTranslation.put("en","EN");
 		  langSupportTranslation.put("fr","FR");
 		  langSupportTranslation.put("it","IT");
 	  }
 	  
 	  if ( langSupportTranslation != null ) {
 	     String Lang = (String)langSupportTranslation.get(sBrowserLanguage);
	     if (Lang !=null ) { 
            LANGUAGE = Lang; 
         } else if (dictionary_default_language.length()>0) {
            LANGUAGE = dictionary_default_language; 
         }
	  }
 	  return LANGUAGE;
   }
   
   // Convert the Oberon dictionary language code to the corresponding ISO-639 language code
   static private String translateOberonLanguageToISO639Language(String sOberonLanguage) {
	  String LANGUAGE = sOberonLanguage;
 	  if (langReverseTranslation == null ) {
 		 langReverseTranslation = new Hashtable();
 		 // Edit this part to define associations
 		 langReverseTranslation.put("EN","en");
 		 langReverseTranslation.put("FR","fr");
 		 langReverseTranslation.put("IT","it");
 	  } 	  
 	  if ( langReverseTranslation != null ) {
 	     String Lang = (String)langReverseTranslation.get(sOberonLanguage);
	     if (Lang !=null ) { LANGUAGE = Lang; }
	  }
 	  return LANGUAGE;
   }   
   
   // Set the application language
   static public void setLanguage(HttpServletRequest request) {
	  String LANGUAGE = "en";
	  HttpSession session = request.getSession();
	  if (use_browser_language) {
		 // Use the browser language 
		 LANGUAGE = translateBrowserLanguageToOberonLanguage(getBrowserLanguage(request));
	  } else {
		 // Use the framework user language if defined
		 Framework framework = (Framework)session.getAttribute("Framework");
 	     if ( framework!=null && framework.getLanguage().length()>0 ) {
 		   LANGUAGE = framework.getLanguage();
 	     } else {
 	       LANGUAGE = translateBrowserLanguageToOberonLanguage(getBrowserLanguage(request));
		   framework.setLanguage(LANGUAGE);
 	     }
	  }
	  session.setAttribute("Language",LANGUAGE);
   }

   static public String getBrowserLanguage(HttpServletRequest request) {
		String sBrowserLang = "en";
	 	String languageStr  = request.getHeader("Accept-Language");
	 	try {
	 	    if ((languageStr != null) && (languageStr.length() > 0)) {
	 	      StringTokenizer LangTokens = new StringTokenizer(languageStr,",");
	 	      if (LangTokens.countTokens() > 0)
	 	    	 sBrowserLang = LangTokens.nextToken();
	 	      else 
	 	    	 sBrowserLang = languageStr;
	 	      if (sBrowserLang!=null) {
	 	    	 sBrowserLang=sBrowserLang.substring(0,2); 
	 	      }
	 	    }
	 	} catch(Exception e) { }
	 	return sBrowserLang;
   }
   
   static public String getInputParameter(String sParameterName,HttpServletRequest request) {
	   String sValue = request.getParameter(sParameterName);
	   if ( sValue!=null ) { return sValue.trim(); } else { return ""; }
   }
   
   static public String getDictCommon(HttpSession session) {
	   String sSection = (String)session.getAttribute("CommonSection");
	   if (sSection==null) { sSection="*"; }
	   return sSection;
   }
   
   static public String getRootPath(HttpSession session) {
	   return (String)session.getAttribute("RootPath")+"/";
   }
   
   static public String getIcon(int sId,HttpSession session) {	  
	  return (String)session.getAttribute("RootPath")+"/servlet/JRImageServlet?id="+sId;
   }
   
   static public String getClassIcon(String sClassName,HttpSession session) {
      return (String)session.getAttribute("RootPath")+"/servlet/JRImageServlet?type=Class%2B&name="+sClassName;
   }
   
   static public String drawClassIcon(String sClassName,HttpSession session) {
      return "<img src=\""+getClassIcon(sClassName,session)+"\" align=absmiddle>";
   }
   
   static public String getHTMLIcon(String iconName,HttpSession session){
      return  "<img src=\"./images/"+iconName+"\" border=0 align=absmiddle>";
   }
   
   static public String switchRowclass(String row) {
	   if (row.equals("dark")) return("light");
	   else return("dark");
   }

   static public String getClassNameRevision(ObjectObj object,HttpSession session) throws Exception{
	  String sCNR = JRClient.getDictKey(dictSection+"*",object.getClassName(),session);
      return sCNR+" <b>"+getNameRevision(object.getName(),object.getRevision())+"</b>";
   }
   
   static public String getNameRevision(String sName,String sRevision) {
       sRevision=sRevision.trim();   
	   if (sRevision.length()>0 && !sRevision.equals("-")) {
		   return sName+nameRevSep+sRevision;
	   } else {
		   return sName;
	   }
   }
   
   static public String getLinkData(Link link,HttpSession session) throws Exception{
	  String sCNRF = JRClient.getDictKey(dictSection+"*",link.getFromClassName(),session);
	  if (link.getFromRevision().length()>0 && !link.getFromRevision().equals("-")) {
		  sCNRF+=" <b>"+link.getFromName()+nameRevSep+link.getFromRevision()+"</b>";
	  } else {
		  sCNRF+=" <b>"+link.getFromName()+"</b>";
	  }
	  String sCNRT = JRClient.getDictKey(dictSection+"*",link.getToClassName(),session);
	  if (link.getToRevision().length()>0 && !link.getToRevision().equals("-")) {
		  sCNRT+=" <b>"+link.getToName()+nameRevSep+link.getToRevision()+"</b>";
	  } else {
		  sCNRT+=" <b>"+link.getToName()+"</b>";
	  }
	  String sType = JRClient.getDictKey(dictSection+"*",link.getLinkType(),session);
      return sType+" "+sCNRF+(link.getBothDir()?" &lt;-&gt; ":" -&gt; ")+sCNRT;
   }
   
   static public String createObjectMenu(HttpSession session) {
	   String sResult="";
       if ( session.getAttribute("Object") != null ) {
    	 try {  
	    	 String sRootPath=getRootPath(session);
			 String sCommonSection = (String)session.getAttribute("CommonSection");
			 if (sCommonSection==null) { sCommonSection="*"; }
	    	 String sMenuSection = (String)session.getAttribute("MenuSection");
	    	 if (sMenuSection==null) { sMenuSection="*"; }
	      	 sResult="\t<li class='line lrt'><a href='#nogo' ><b class='arrow'><img src=\""+
	      	             sRootPath+menu_files_path+"/object.gif\" align=absmiddle border=0> "+
	      	             JRClient.getDictKey(sMenuSection+","+sCommonSection,"Object Options",session)+"</b></a>\n";
	      	 sResult+="\t <ul class='sub rt'>\n";
	      	 ObjectObj object=(ObjectObj)session.getAttribute("Object");
	      	 Vector vCommands = JRClient.getObjectMenuCommands(object,session);
	   	     for (int i=0;i<vCommands.size();i++) {
			   Command command = (Command)vCommands.elementAt(i); 
			   String sHref=command.getHRef();
			   if ( sHref.startsWith("#") ) {
				  StringTokenizer sT=new StringTokenizer(sHref.substring(1),";");
				  sResult+="\t  <li><a href='#nogo' onClick=\"openLink('"+sRootPath+sT.nextToken()+"&id="+java.net.URLEncoder.encode(object.getObjId())+"','"+sT.nextToken()+"','"+sT.nextToken()+"')\""; 
		  	   } else {
				  sResult+="\t  <li><a href='"+sRootPath+JRClient.replaceObjectKeyWords(sHref,object,session)+(sHref.indexOf("?")>0?"&":"?")+"id="+java.net.URLEncoder.encode(object.getObjId())+"'";
		 	   }
			   sResult+=">"+JRClient.getDictKey(sMenuSection+","+sCommonSection,command.getLabel(),session)+"</a></li>\n";
			 }
	      	 sResult+="\t </ul>\n\t</li>\n";
    	 } catch (Exception e) {
    		 session.putValue("error.message","Create object menu FAILED: <br>"+
    	    		 JRClient.replaceString(e.getMessage(),"\n","<br>") );
    	 }
      }
      return sResult;
   }
   
   static public String getErrorMessage(HttpSession session) {
       String sMessage = (String)session.getValue("error.message");
	   if (sMessage!=null) {
	 	 int iline=sMessage.indexOf(", on line");
		 if (iline>0) sMessage=sMessage.substring(0,iline);
		 session.removeValue("error.message");
	   } else {
		 sMessage="";
	   }
	   return sMessage;
   }
%>