<%@include file ="include.jsp"%>
<%! 
    private static String convertJSONTree(int level,Vector vLinks,HttpSession session) throws Exception{
	    String JSONTree = "";
	    int i=0;
	    Vector vSubTree = null; 
	    while (i<vLinks.size()) {
	    	//out.println((String) vLinks.elementAt(i));
	    	Vector vData = JRClient.StringTokensToVector((String) vLinks.elementAt(i),"<|>");
	    	int iLevel = Integer.parseInt((String)vData.elementAt(0));
	    	if (iLevel==level) {
	    		if (vSubTree!=null) {
	    			JSONTree+="children: ["+convertJSONTree(level+1,vSubTree,session)+"] },";
	    		}
	    		JSONTree+="{id: \"node"+level+"."+i+"_"+(String)vData.elementAt(6)+"\",";
	    		String sClassName = (String)vData.elementAt(3);
	    		JSONTree+="name: \"<img align=absmiddle src='"+getClassIcon(sClassName,session)+"'> "+
	    		      JRClient.getDictKey(dictSection+"*",sClassName,session)
	    		      +"<br><b>"+(String)vData.elementAt(4)+nameRevSep+(String)vData.elementAt(5)+"</b>\",";
	    		JSONTree+="data: {},";
	    		vSubTree=new Vector();
	    	} else {
	    		vSubTree.add( vLinks.elementAt(i) );
	    	}	    	
	    	i++;
	    }	    
	    if (vSubTree!=null) {
			JSONTree+="children: ["+convertJSONTree(level+1,vSubTree,session)+"] }";
		}
	    return JSONTree;
    } 

%>
<%
	//Object
	String sID = getInputParameter("id",request);
	ObjectObj object = JRClient.loadObject(sID,"description lifecycle currentstage ",session);  
	session.setAttribute("Object",object);
	String sCommonSection = getDictCommon(session);

	String sLinkType  = request.getParameter( "linktype");
	if (sLinkType == null){  sLinkType = "*";  }
	    
	String sCommand="object navigate "+sID+" from linktype '"+sLinkType+"' level 3 get { id } token '<|>';";
    Vector vRes=JRClient.performOOQLCommands(sCommand,session);
    Vector vLinks = JRClient.StringTokensToVector((String)vRes.elementAt(0), "\n");
   
    String JSONTree = convertJSONTree(1,vLinks,session);
    
    // Menu Bar 
    String sTitle= getClassNameRevision(object,session);
    String sSubTitle = JRClient.getDictKey(sCommonSection,"SpaceTree",session);                   
%>
<jsp:include page ="../menu.jsp" flush="true">
	<jsp:param name="title" value="<%= sTitle %>" />
	<jsp:param name="subtitle" value="<%= sSubTitle %>" />
</jsp:include>

<STYLE type=text/css media=screen>@import url( ./css/spacetree.css );</STYLE>
<!--[if IE]><script language="javascript" type="text/javascript" src="<%= getRootPath(session) %>scripts/excanvas.js"></script><![endif]-->
<script language="javascript" type="text/javascript" src="<%= getRootPath(session) %>scripts/jit-yc.js"></script>
<script language="javascript">

    var Log = {
	    elem: false,
	    write: function(text){
	        if (!this.elem) 
	            this.elem = document.getElementById('log');
	        this.elem.innerHTML = text.replace("<br>"," ");
	        this.elem.style.left = (500 - this.elem.offsetWidth / 2) + 'px';
	    }
	};

	function addEvent(obj, type, fn) {
	    if (obj.addEventListener) obj.addEventListener(type, fn, false);
	    else obj.attachEvent('on' + type, fn);
	};

	function init(){
	    function get(id) {
	      return document.getElementById(id);  
	    };
	    //init data
	    var json = {
		            id: "node0_<%= sID %>",
		            name: "<img align=absmiddle src='<%=getClassIcon(object.getClassName(),session)%>'> <%=
		            	JRClient.getDictKey(dictSection+"*",object.getClassName(),session)
		            	+"<br><b>"+object.getName()+nameRevSep+object.getRevision()%></b>",
		            data: {},
		            children: [ <%= JSONTree %> ]
	    	    } ;

	    //end
	    var infovis = document.getElementById('infovis');
	    var w = infovis.offsetWidth, h = infovis.offsetHeight;
	    //init canvas
	    //Create a new canvas instance.
	    var canvas = new Canvas('mycanvas', {
	        'injectInto': 'infovis',
	        'width': w,
	        'height': h,
	        'backgroundColor': '#1a1a1a'
	    });
	    //end
	    
	    //init st
	    //Create a new ST instance
	    var st = new ST(canvas, {
	        //set duration for the animation
	        duration: 300,
	        //set animation transition type
	        transition: Trans.Quart.easeInOut,
	        //set distance between node and its children
	        levelDistance: 50,
	        //set node and edge styles
	        //set overridable=true for styling individual
	        //nodes or edges
	        Node: {
	            height: 30,
	            width: 130,
	            type: 'rectangle',
	            color: '#000',
	            overridable: true
	        },
	        
	        Edge: {
	            type: 'bezier',
				color: '#000',
	            overridable: true
	        },
	        
	        onBeforeCompute: function(node){
	            Log.write("loading .... " + node.name);
	        },
	        
	        onAfterCompute: function(){
	            Log.write("ready");
	        },
	        
	        //This method is called on DOM label creation.
	        //Use this method to add event handlers and styles to
	        //your node.
	        onCreateLabel: function(label, node){
	            label.id = node.id;            
	            label.innerHTML = node.name;
	            label.onclick = function(){
	                st.onClick(node.id);
	            };
				label.ondblclick = function(){
				    var objID = node.id.split("_")[1];
	                window.open("edit.jsp?id="+escape(objID));
	            }; 
	            //set label styles
	            var style = label.style;
	            style.width = 170 + 'px';
	            style.height = 27 + 'px';            
	            style.cursor = 'pointer';
	            style.color = '#000';
	            style.fontSize = '0.8em';
	            style.textAlign= 'left';
	            style.paddingTop = '2px';
				style.paddingLeft = '2px';
	        },
	        
	        //This method is called right before plotting
	        //a node. It's useful for changing an individual node
	        //style properties before plotting it.
	        //The data properties prefixed with a dollar
	        //sign will override the global node style properties.
	        onBeforePlotNode: function(node){
	            //add some color to the nodes in the path between the
	            //root node and the selected node.
	            if (node.selected) {
	                node.data.$color = "#99aaFF";
	            }
	            else {
	                delete node.data.$color;
	                var GUtil = Graph.Util;
	                //if the node belongs to the last plotted level
	               // if(!GUtil.anySubnode(node, "exist")) {
	                    //count children number
	                    var count = 0;
	                    GUtil.eachSubnode(node, function(n) { count++; });
	                    //assign a node color based on
	                    //how many children it has
						node.data.$color = ['#a0a0aa', '#b0b0bb', '#c0c0cc', '#d0d0dd', '#e0e0ee', '#f0f0ff'][count];                    
	               // }
	            }
	        },
	        
	        //This method is called right before plotting
	        //an edge. It's useful for changing an individual edge
	        //style properties before plotting it.
	        //Edge data proprties prefixed with a dollar sign will
	        //override the Edge global style properties.
	        onBeforePlotLine: function(adj){
	            if (adj.nodeFrom.selected && adj.nodeTo.selected) {
	                adj.data.$color = "#F00";
	                adj.data.$lineWidth = 3;
	            }
	            else {
	                delete adj.data.$color;
	                delete adj.data.$lineWidth;
	            }
	        }
	    });
	    //load json data
	    st.loadJSON(json);
	    //compute node positions and layout
	    st.compute();
	    //optional: make a translation of the tree
	    //st.geom.translate(new Complex(-200, 0), "startPos");
	    //emulate a click on the root node.
	    st.onClick(st.root);
	    //end
	    //Add event handlers to switch spacetree orientation.
	    var dirswitch = get('dirswitch');
	    
	    function changeHandler() {
	    	    dirswitch.disabled =  true;
	            st.switchPosition(dirswitch.options[dirswitch.selectedIndex].value, "animate", {
	                onComplete: function(){
	            	    dirswitch.disabled =  false;
	                }
	            });
	    };
	    
	    dirswitch.onchange = changeHandler;
	    //end

	}
		
</script>
<body onload="init();">
<br>
<br>
<form>
  <table><tr><td>
    Orientation: <select id="dirswitch" >
      <option>left</option>
      <option>top</option>
      <option>right</option>
      <option>bottom</option>
    </select>
 </td></tr></table>
</form>
<div id="container">

<div id="center-container">
    <div id="infovis"></div>    
</div>
  
<div id="log"></div>
</div>
</body>

</html>